/*
 *	for GOGO-no-coda
 *	Copyright (C) 2001 gogo-developer
 */

#ifndef	USE_LIBSND

#include <assert.h>
#include "common.h"
#include "global.h"
#include "tool.h"
#include "gogo.h"
#include "lame.h"
#include "vbrtag.h"
#include "basic_io.h"
#include "filehead.h"
#include "bitstream.h"

/* open file and read wave header */
MERET
initFileIO(void)
{
	unsigned int size;
	int freq, bit, channel;
	int outputOffset;

	/* ̓foCXI܂ */
	if( RO.input_device == IDEV_ILL ){
		if( RO.userIn.pUserFunc )
			RO.input_device = IDEV_UFUNC;
#ifndef	_USRDLL
		else if( strcmp( RO.inFileName, "stdin" ) == 0 )
			RO.input_device = IDEV_STDIN;
#endif
		else
			RO.input_device = IDEV_FILE;
	}

	/* o̓foCXI܂ */
	if( RO.output_device == ODEV_ILL ){
		if( RO.userOut ) {
			RO.output_device = ODEV_UFUNC;
			RO.output_format = OFMT_MP3;
#ifndef	_USRDLL
		} else if( RO.input_device == IDEV_STDIN ) {
			RO.output_device = ODEV_STDOUT;
#endif
		} else  {
			RO.output_device = ODEV_FILE;
		}
	}
#ifdef WIN32
	#define	STR_NOCASECOMP		stricmp
#elif __linux__
	#define STR_NOCASECOMP		strcasecmp
#else
	#define STR_NOCASECOMP		strcmp
#endif
	if(	RO.output_device == ODEV_FILE && RO.outFileName[0] == '\0'){
		char name[MAX_FILE_LEN];
		const char *pExt;
		switch( RO.output_format ){
		default: //assert( 0 ); // break Ȃ
			RO.output_format = OFMT_MP3;
		case OFMT_MP3: pExt = ".mp3"; break;
		case OFMT_WAV: pExt = ".wav"; break;
		case OFMT_RMP: pExt = ".rmp"; break;
		}
		if(changeSuffix(name, RO.inFileName, pExt, MAX_FILE_LEN) == ERR) return ME_INTERNALERROR;
		strcpy(RO.outFileName, name);
	} else if( RO.output_format == OFMT_ILL ) {
		char	*pExt = strrchr( RO.outFileName, '.' );

		RO.output_format = OFMT_MP3;
		if ( pExt ) {
			if( STR_NOCASECOMP( pExt, ".wav" ) == 0 || 
				STR_NOCASECOMP( pExt, ".wave" ) == 0 ){
				RO.output_format = OFMT_WAV;
			} else
			if( STR_NOCASECOMP( pExt, ".rmp" ) == 0 ) {
				RO.output_format = OFMT_RMP;
			} else
			if( STR_NOCASECOMP( pExt, ".raw" ) == 0 ){
				RO.output_format = OFMT_MP3;
			}
		}
	}

	/****   input device   ***/
	initBasicIO();
	switch( RO.input_device ){
	case IDEV_UFUNC:
		size = RO.userIn.nSize;
		bit = RO.userIn.nBit;
		channel = RO.userIn.nChn;
		freq = RO.userIn.nFreq;
		RO.input_format = IFMT_RAW;		/* ȊO̓̓tH[}bg͑IłȂ */
		break;
	case IDEV_STDIN:
		if(openInputFile( "stdin" ) == ERR) return ME_INTERNALERROR;
		break;
	default: assert(0);
	case IDEV_FILE:
		if(openInputFile(RO.inFileName) == ERR) return ME_INFILE_NOFOUND;
	}

	/* gq̓tH[}bg𐄑Ă */
	/* t@Ce`𐄑邽߂ɂ͑ʂugetc\ȃobt@KvƂȂ */

	if( RO.input_format == IFMT_ILL ){
		char	*pExt = strrchr( RO.inFileName, '.' );

		RO.input_format = IFMT_WAV;					// DFLT
		if( pExt != NULL ){
			if( STR_NOCASECOMP( pExt, ".wav" ) == 0 || 
				STR_NOCASECOMP( pExt, ".wave" ) == 0 ){
				RO.input_format = IFMT_WAV;
			} else
			if( STR_NOCASECOMP( pExt, ".aif" ) == 0 || 
				STR_NOCASECOMP( pExt, ".aiff" ) == 0 ||
				STR_NOCASECOMP( pExt, ".aifc" ) == 0 ){
				RO.input_format = IFMT_AIF;
			} else
			if( STR_NOCASECOMP( pExt, ".raw" ) == 0 ){
				RO.input_format = IFMT_RAW;
			} else {
				closeInputFile();
				return ME_INTERNALERROR;
			}
		}
	}

	switch( RO.input_format ){
	case IFMT_RAW:
/*
		bit = 16;
		channel = RO.nChannel;
		freq = RO.inpFreqHz;
		size = RO.nSample * (bit / 8) * channel;
*/
		break;
	case IFMT_WAV:
		/* analyze wav-header */
		if(getWaveInfo(&size, &bit, &freq, &channel) == ERR){
			closeInputFile();
			return ME_WAVETYPE_ERR;
		}
		break;
	case IFMT_AIF:
		/* analyze aiff-header */
		assert( 0 );
		closeInputFile();
		return ME_INTERNALERROR;
		break;
	}

	if(bit != 16 || (channel != 1 && channel != 2)){
		return ME_WAVETYPE_ERR;
	}

	RO.nChannel = channel;
	RO.inpFreqHz = freq;
	RO.nSample = size / (channel * bit / 8);

	/***   output device   ***/
	if( RO.output_device == ODEV_FILE ){
		if(openOutputFile(RO.outFileName) == ERR) return ME_OUTFILE_NOFOUND;
	}

	// rbgXg[̏
	init_bit_stream_w();

	/* tH[}bg̃t@C擪 mp3 {̂ւ̃ItZbg̐ݒ */
	switch( RO.output_format ) {
		case OFMT_MP3: 
			outputOffset = 0;
			break;
		case OFMT_WAV: 
			outputOffset = SizeOfCkWave;
			break;
		case OFMT_RMP: 
			outputOffset = SizeOfCkRmp;
			break;
		default:
			assert( 0 );
			return ME_INTERNALERROR;
	}

	/* mp3 {̂̑Oɓf[^󂯂Ă */
	{
		extern	void	putbits2(int val, int j);
		int seekPoint = outputOffset;
		char	nulldata = 0;
		while( seekPoint ){
			writeData( &nulldata, sizeof( nulldata ) );
			seekPoint--;
		}
	}

	return ME_NOERR;
} /* initFileIO */


static FILE *infp;
static FILE *outfp;
static size_t sizeWrite;
void
initBasicIO( void )
{
	infp = outfp = NULL;
	sizeWrite = 0;
} /* initBasicIO */

int
openInputFile(char *fname)
{
	if(!strcmp(fname, "stdin")){
		infp = stdin;
		setBinaryMode(infp);
	}else{
		infp = fopen(fname, "rb");
		if(!infp) return ERR;
	}
	return NOERR;
} /* openInputFile */

void
closeInputFile(void)
{
	if( infp && infp != stdin) fclose(infp);
} /* closeInputFile */

int
openOutputFile(char *fname)
{
	sizeWrite = 0;
	outfp = fopen(fname, "wb+");
	if(!outfp) return ERR;
	return NOERR;
} /* openOutputFile */

void
closeOutputFile(void)
{
	if( RO.userOut != MPGE_NULL_FUNC ){
		RO.userOut( NULL, 0 );
	} else
	if( outfp && outfp != stdout ) fclose(outfp);
} /* closeOutputFile */

size_t
readData(unsigned char *data, size_t size)
{
	if( RO.userIn.pUserFunc != MPGE_NULL_FUNC ){
		return	(RO.userIn.pUserFunc( data, size ) == ME_NOERR ) ? size : 0;
	}else{
		return fread(data, 1, size, infp);
	}
	return -1;
} /* readData */

size_t
writeData(unsigned char *data, size_t size)
{
	sizeWrite += size;
	if( RO.userOut != MPGE_NULL_FUNC ){
		return	( RO.userOut(data, size ) == ME_NOERR ) ? size : 0;
	}else{
		return fwrite(data, 1, size, outfp);
	}
} /* writeData */

void
write_fileheader( void )
{
	int		bWriteVBR  = (RO.VBR != vbr_off);

	/* o͂t@C̎̂ݏ */
	size_t		sizeWriteStream = getWriteStreamSize();
	if( RO.output_device == ODEV_FILE ){
		#define	fwritestream(var)	fwrite(&(var), sizeof(var), 1, stream)
		/* tH[}bgʂɏ */
		int			nQuality = RO.VBR_q*100/9;
		switch( RO.output_format ) {
			case OFMT_MP3:
				if( bWriteVBR ){
//					PutVbrTag( outfp, nQuality); 
					int nQuality=RO.VBR_q * 100 / 9;
					void	*pVBRTag;
					FILE*	stream = outfp;
					size_t	sizeResult;
				
					pVBRTag =	NULL;
					if( CreateVbrTag( &pVBRTag, &sizeResult, nQuality, sizeWriteStream) == 0 ){
						fseek( stream, 0, SEEK_SET );
						fwrite(pVBRTag, sizeResult, 1, stream);
					}
					if( pVBRTag != NULL ) free( pVBRTag );

				}
				break;
			case OFMT_WAV: {
					struct CK_WAVE header;
					FILE*	stream;
					int		fileSize;
					int		dataSize;
					
					stream = outfp;//fopen(szOutFile,"rb+");
					//if (stream==NULL) return ME_OUTFILE_NOFOUND;
					fseek(stream, 0, SEEK_END);
					fileSize = sizeWriteStream;//ftell(stream);
					dataSize = fileSize - SizeOfCkWave;
					if( fileSize % 2 ) {
						fputc(0, stream);
						fileSize++;
					}
					fseek(stream, 0, SEEK_SET);

					memmove( &(header.riff.chunk), "RIFF", 4);
					header.riff.size = fileSize-8;
					if( RO.riffInfo.riffInfosLen ) {
						header.riff.size += RO.riffInfo.riffInfosLen+12;
					}
					memmove( &(header.riff.form), "WAVE", 4);
					
					memmove( &(header.fmt.chunk), "fmt ", 4);
					header.fmt.size = SizeOfCkFmt-8;
					header.fmt.formatID = 0x55;
					header.fmt.num_of_channel = RO.nChannel;
					header.fmt.srate = RO.out_samplerate;
					header.fmt.avg_bytes_per_sec = RO.VBR ? 1.0*(fileSize-SizeOfCkWave)*header.fmt.srate/(1.0*RW.frameNum*RO.framesize) : RO.rateKbps*1000/8;
					header.fmt.block_size = 1;
					header.fmt.bits_per_sample = 0;
					header.fmt.cbSize = 12;
					header.fmt.wID = 1;
					header.fmt.fdwFlags = 2;
					header.fmt.nBlockSize = RO.VBR ? 144.0*320000/header.fmt.srate : 144.0*RO.rateKbps*1000/header.fmt.srate;
					header.fmt.nFramesPerBlock = 1;
					header.fmt.nCodecDelay = 0x0571;
					
					memmove( &(header.fact.chunk), "fact", 4);
					header.fact.size = SizeOfCkFact-8;
					header.fact.num_of_sample = RW.frameNum*RO.framesize;
					
					memmove( &(header.data.chunk), "data", 4);
					header.data.size = dataSize;

					fwritestream(header.riff.chunk);
					fwritestream(header.riff.size);
					fwritestream(header.riff.form);
					
					fwritestream(header.fmt.chunk);
					fwritestream(header.fmt.size);
					fwritestream(header.fmt.formatID);
					fwritestream(header.fmt.num_of_channel);
					fwritestream(header.fmt.srate);
					fwritestream(header.fmt.avg_bytes_per_sec);
					fwritestream(header.fmt.block_size);
					fwritestream(header.fmt.bits_per_sample);
					fwritestream(header.fmt.cbSize);
					fwritestream(header.fmt.wID);
					fwritestream(header.fmt.fdwFlags);
					fwritestream(header.fmt.nBlockSize);
					fwritestream(header.fmt.nFramesPerBlock);
					fwritestream(header.fmt.nCodecDelay);

					fwritestream(header.fact.chunk);
					fwritestream(header.fact.size);
					fwritestream(header.fact.num_of_sample);

					fwritestream(header.data.chunk);
					fwritestream(header.data.size);

					if( bWriteVBR ){
						int nQuality=RO.VBR_q * 100 / 9;
						void	*pVBRTag;
						size_t	sizeResult;
					
						pVBRTag =	NULL;
						if( CreateVbrTag( &pVBRTag, &sizeResult, nQuality, dataSize) == 0 ){
							fwrite(pVBRTag, sizeResult, 1, stream);
						}
						if( pVBRTag != NULL ) free( pVBRTag );
					}
					
					if( RO.riffInfo.riffInfosLen ) {
						struct CK_LIST list;
						fseek(stream, 0, SEEK_END);
						memmove(&(list.chunk), "LIST", 4);
						list.size = RO.riffInfo.riffInfosLen+4;
						memmove( &(list.form), "INFO", 4);

						fwritestream(list.chunk);
						fwritestream(list.size);
						fwritestream(list.form);

						fwrite(RO.riffInfo.pRiffInfos, RO.riffInfo.riffInfosLen, 1, stream);
					}
					
					//fclose(stream);
				}
				break;
			case OFMT_RMP: {
					struct CK_RMP header;
					FILE*	stream;
					int		fileSize;
					int		dataSize;

					stream = outfp;

//					stream=fopen(szOutFile,"rb+");
//					if (stream==NULL) return ME_OUTFILE_NOFOUND;
					fseek(stream, 0, SEEK_END);
					fileSize = sizeWriteStream;		//ftell(stream);
					dataSize = fileSize-SizeOfCkRmp;
					if( fileSize % 2 ) {
						fputc(0, stream);
						fileSize++;
					}
					fseek(stream, 0, SEEK_SET);

					memmove( &(header.riff.chunk), "RIFF", 4);
					header.riff.size = fileSize-8;
					if( RO.riffInfo.riffInfosLen ) {
						header.riff.size += RO.riffInfo.riffInfosLen+12;
					}
					memmove( &(header.riff.form), "RMP3", 4);
					
					
					memmove( &(header.data.chunk), "data", 4);
					header.data.size = dataSize;
					
					fwritestream(header.riff.chunk);
					fwritestream(header.riff.size);
					fwritestream(header.riff.form);
					
					fwritestream(header.data.chunk);
					fwritestream(header.data.size);

					if( bWriteVBR ){
						int nQuality=RO.VBR_q * 100 / 9;
						void	*pVBRTag;
						size_t	sizeResult;
					
						pVBRTag =	NULL;
						if( CreateVbrTag( &pVBRTag, &sizeResult, nQuality, dataSize) == 0 ){
							fwrite(pVBRTag, sizeResult, 1, stream);
						}
						if( pVBRTag != NULL ) free( pVBRTag );
					}
					
					if( RO.riffInfo.riffInfosLen ) {
						struct CK_LIST list;
						fseek(stream, 0, SEEK_END);
						memmove(&(list.chunk), "LIST", 4);
						list.size = RO.riffInfo.riffInfosLen+4;
						memmove( &(list.form), "INFO", 4);

						fwritestream(list.chunk);
						fwritestream(list.size);
						fwritestream(list.form);

						fwrite(RO.riffInfo.pRiffInfos, RO.riffInfo.riffInfosLen, 1, stream);
					}
					
//					fclose(stream);
				}
				break;
		}
		#undef	fwritestream
	}
	else	/* by kazumi-t@ss.iij4u.or.jp */
	if( RO.userOut != MPGE_NULL_FUNC && RO.useVbrTagWithUserOut && bWriteVBR ){
		/* Xg[͂̎VBRTag݂ kazumi-t@ss.iij4u.or.jp
		 * mc_userStore( NULL, 0 ); ̌ďoɃR[obN鑤
		 * t@C|C^擪փV[N(߂l̓t@CTCY)B
		 */
		if( 0 < writeData( NULL, 0) ){
			int nQuality=RO.VBR_q * 100 / 9;
			void	*pVBRTag;
			size_t	sizeResult;
		
			pVBRTag =	NULL;
			if( CreateVbrTag( &pVBRTag, &sizeResult, nQuality, sizeWriteStream) == 0 ){
				writeData(pVBRTag, sizeResult);
			}
			if( pVBRTag != NULL ) free( pVBRTag );
		}
	}
}


void
lame_mp3_tags_fid(void)
{
	if(RO.VBR && outfp != NULL && outfp != stdout ){
		/* Map VBR_q to Xing quality value: 0=worst, 100=best */
		int nQuality = ((9-RO.VBR_q) * 100) / 9;

		/* Write Xing header again */
		if(!fseek(outfp, 0, SEEK_SET)) PutVbrTag(outfp, nQuality);
	}
} /* lame_mp3_tags_fid */

size_t
getWriteStreamSize(void)
{
	return	sizeWrite;
}

#endif	/* !USE_LIBSND */
